﻿/// <reference path="Js/jquery.min.js" />
var ws;
var timeout;
var messageCount = 0;
var messageType = "0";
var funError = new Function();

var DEVICE = new Function();
var LOGINSTATE = new Function();
var CALLSTATE = new Function();
var TALKVOCID = new Function();
var teleAgent = {
    SliceType: "",
    SliceNo: "",

    CompanyAccount: '',
    AgentNo: "",
    Password: "",
    WebSocketLineUrl: "",

    PhoneState: 0,



    //     PHONESTATE:  --- 话机状态 ---                                   对应主要信息
    //ST_INITDEV           = 0;                                       初始化中
    //   ST_IDLE               = 1;                                       挂机
    //   ST_CHEDKDIALTONE   = 2;                                       摘机准备呼出
    //   ST_PRECALL           = 3;  //  检测是否预拨号                   内线话机摘机准备拨号
    //   ST_CALLOUT           = 4;  // 已区分了拨叫内线或外线            摘机呼出
    //   ST_RING               =  5;                                     振铃
    //   ST_TALK               = 6;                                       通话
    //   ST_DISCONNECT       = 7;                                       电话线断开


    PHONESTATE: ['初始化', '挂机', '摘机', '拨号', '呼出', '振铃', '通话', '断开'],

    StateDic: ["空闲", "通话", "震铃", "收到按键", "呼出", "空闲", "未应答来电", "开始录音", "停止录音", "呼叫失败", "", "", "", "", ""],

    TimeState: 0,
    //DEVTYPE:  3    录音型.  2    外呼型   4    混合型
    DevType: 0,
    DevTypeDic: ["未知", "未知", "外呼型", "录音型", "混合型"],
    //DEVSTATE ： -1    故障  0    正常初始化   1    OK     2    告警 
    DevState: 0,
    DevStateDic: ["未知", "故障", "正在初始化", "设备正常", "告警"],
    Constant: {
        DevState: {
            DevERROR: 1,
            DevINIT: 2,
            DelSUCCESS: 3,
            DelALARM: 4
        },
        DevType: {
            DevCallout: 2,
            DevRecord: 3,
            DevOTHER: 4
        },
        State: {
            TALK: 1, //通话
            RING: 2, //震铃
            DTMF: 3, //按键
            OFFHOOK: 4, //摘机
            ONHOOK: 5, //挂机
            NOANSWER: 6, //未接
            BEGINRECORD: 7, //开始录音
            ENDRECORD: 8//结束录音

        }
    },
    Times: function () {
        if (teleAgent.TimeState > 0) {
            teleAgent.TimeState--;
        }
    },
    Login: function (CompanyAccount, AgentNo, Password) {
        var Data = '{"ACTION":"LOGIN","COMPANY":"' + CompanyAccount + '","USER":"' + AgentNo + '","PSW":"' + Password + '"}';
        ws.send(Data);
    },
    Close: function () {
        ws.close();
    },
    Connect: function (Sockect_port) {

        setInterval(teleAgent.Times, 1000);

        //        teleAgent.CompanyAccount = CompanyAccount;
        //        teleAgent.AgentNo = AgentNo.toString();
        //        teleAgent.Password = Password.toString();
        teleAgent.WebSocketLineUrl = 'ws://127.0.0.1:' + Sockect_port + '/sgc/auth/url//';
        //        if (teleAgent.AgentNo == undefined || teleAgent.Password == undefined || teleAgent.AgentNo == "" || teleAgent.Password == "") {
        //            funError();
        //            return;
        //        }
        //clearTimeout(timeout)
        try {
            //var SOCKECT_ADDR = teleAgent.teleAgentUrl
            //192.168.0.106
            var SOCKECT_ADDR = teleAgent.WebSocketLineUrl; // 'ws://127.0.0.1:8888/sgc/auth/url//'; // teleAgent.teleAgentUrl;
            ws = new WebSocket(SOCKECT_ADDR);
            //alert('2');
            ws.onopen = function (event) {
                messageCount = 0;
                //{"ACTION":"LOGIN","COMPANY":"企业账号","USER":"用户账号","PSW":"MD5密码"}
                //alert('1');
                //AgentContent('1');
                funError(event);
            };
            ws.onmessage = function (event) {
                var data = JSON.parse(event.data);
                //alert(data);
                if (data.EVENT == "DEVICE") {
                    //.DEVSTATE, data.DEVINFO
                    teleAgent.DevType = data.DEVTYPE;
                    teleAgent.DevState = parseInt(data.DEVSTATE, 0) + 2;
                    DEVICE(data);
                    return;
                }
                if (data.EVENT == "LOGINSTATE") {
                    //.COMPANY,data.USER,data.ERRCODE,data.ERRMSG
                    LOGINSTATE(data);
                    return;
                }

                if (data.EVENT == "CALLSTATE") {
                    //.TELNO, data.STATE, data.STATEMSG, data.CALLTYPE
                    //4 
                    //录音型 摘机后呼叫时延迟3秒发码呼叫
                    if (teleAgent.DevType == teleAgent.Constant.DevType.DevCallout && data.STATE == teleAgent.Constant.State.OFFHOOK) {
                        teleAgent.TimeState = 3;
                    }
                    if (data.STATE == teleAgent.Constant.State.OFFHOOK) {
                        teleAgent.TimeState = 3;
                    }

                    if (data.STATE == teleAgent.Constant.State.TALK ||
                    data.STATE == teleAgent.Constant.State.OFFHOOK ||
                    data.STATE == teleAgent.Constant.State.ONHOOK
                    ) {
                        teleAgent.PhoneState = data.STATE;
                        CALLSTATE(data);
                    }
                    else if (data.STATE == teleAgent.Constant.State.BEGINRECORD) {
                        TALKVOCID(data);
                    }
                    else {
                        //CALLSTATE(data);
                    }



                    return;
                }
            };
            ws.onclose = function (event) {
                //                if (messageType == "7") {
                //                    return;
                //                }
                funError(event);

            };
            ws.onerror = function (event) {

                funError(event);

            };
        } catch (ex) {

        }
    },
    CALLOUT: function (param1, param2, param3) {
        var Data = '{"ACTION":"CALLOUT","TELENO":"' + param1 + '#","CUSTOMERID":"' + param2 + '","TASKID":"' + param3 + '"}';
        ws.send(Data);
    },
    SETCUSTOMER: function (param1) {
        var Data = '{"ACTION":"SETCUSTOMER","CUSTOMERID":"' + param1 + '"}';
        ws.send(Data);
    },
    SENDDTMF: function (param1) {
        var Data = '{"ACTION":"SENDDTMF","TELENO":"' + param1 + '"}';
        ws.send(Data);
    },
    ONHOOK: function () {
        var Data = '{"ACTION":"ONHOOK"}';
        ws.send(Data);
    },
    OFFHOOK: function () {
        var Data = '{"ACTION":"OFFHOOK"}';
        ws.send(Data);
    },
    doAction: function (action, param1, param2, param3) {

        switch (action) {
            case 'CALLOUT':
                //呼出

                //                data.STATE == teleAgent.Constant.State.TALK ||
                //                    data.STATE == teleAgent.Constant.State.OFFHOOK ||
                //                    data.STATE == teleAgent.Constant.State.ONHOOK



                if (teleAgent.PhoneState == teleAgent.Constant.State.TALK || teleAgent.PhoneState == teleAgent.Constant.State.OFFHOOK) {
                    teleAgent.TimeState = 1;
                    this.ONHOOK();

                    // alert('PhoneState:' + teleAgent.PhoneState + ' TimeState:' + teleAgent.TimeState);
                }
                //PhoneState


                if (teleAgent.TimeState == 0) {
                    // alert('CALLOUT' + teleAgent.TimeState);

                    this.CALLOUT(param1, param2, param3);
                } else {
                    //alert('CALLOUT 延迟：' + teleAgent.TimeState);

                    setTimeout('teleAgent.CALLOUT("' + param1 + '","' + param2 + '","' + param3 + '");', teleAgent.TimeState * 1000);
                }
                //this.CALLOUT(param1, param2, param3);
                break;

            case 'SETCUSTOMER':
                //设置客户
                this.SETCUSTOMER(param1);
                break;
            case 'SENDDTMF':
                //发码
                this.SENDDTMF(param1);
                break;
            case 'ONHOOK':
                //挂机
                //alert('ONHOOK');
                teleAgent.TimeState = 3;
                this.ONHOOK();
                break;

            case 'OFFHOOK':
                //摘机
                teleAgent.TimeState = 3;
                this.OFFHOOK();
                break;

            default:
                break;

        }
    },

    DEVICE: function (fun) {
        DEVICE = fun;
    },
    LOGINSTATE: function (fun) {
        LOGINSTATE = fun;
    },
    CALLSTATE: function (fun) {
        CALLSTATE = fun;
    },
    TALKVOCID: function (fun) {
        TALKVOCID = fun;
    },
    funError: function (fun) {
        funError = fun;
    },
    GetRecord: function (url, RecordId, fun) {
        if (url == "" || RecordId == "") {
            fun("参数不能为空字符");
            return;
        }
        $.ajax({
            type: 'post',
            async: false,
            dataType: "html",
            url: url,
            data: { RecordId: RecordId },
            error: function (msg) {
                fun("error")
            },
            success: function (data) {
                fun(data);
            }
        })
    }
};
$(window).bind('unload', function () {
    // 只有在标识变量is_confirm不为false时，才弹出确认提示
    //    if (window.is_confirm !== false) {
    //        return '您可能有数据没有保存';
    //    }
    //   window.top.ws.close();
    //    console.log('socket close');
});

//$(window).beforeunload(function () { alert("Goodbye!"); }); 